// Kommentare
// 1. node.js installieren
// 2. node server.js    ... aufzurufen. Wenn node nicht erkannt wird,
//                          PATH Variable setzen
// 3. npm install -g nodemon     ... nodemon nachinstalliert
//                                   npm .. node package manager
// 4. nodemon server.js
// 5. package.json  ... Definition der benötigten Bibliotheken + Version
// 6. im Order von server.js
//         npm install      ... dann werden die in package.json definierten
//                              Bibliotheken heruntergeladen

var port=8080;

// Bibliotheken werden geladen
var http = require('http');
var url = require('url');
var Path = require('path');
var fs = require('fs');
var SerialPort = require('./wgserial');

// Definition eine Variable für die Ein- und Ausgänge
var IOimage={};
IOimage.taster = 0;
IOimage.led = 0;


var serial = SerialPort({
  comport: "/dev/ttyUSB0",
  baudrate: 115200,
  ondata: function(s)
  {
    // Daten in Variable <s> wurden empfangen
    for(var i=0; i<s.length;i++)
    {
      if (s[i]=='B') IOimage.taster = 1;
      if (s[i]=='b') IOimage.taster = 0;
    }
  }
});

setInterval(
  function(){
    // Diese Funktion wird im 50ms Intervall aufgerufen
    if (IOimage.led==1) serial.write("A");
    if (IOimage.led==0) serial.write("a");
  },
  50);

var server = http.createServer(
  function(request, response) {
    // Aufruf bei einer Anfrage (Request) vom Browser und die Antwort
    // (Response) wird zurückgeschickt.
    var path = url.parse(request.url, true);
    var query = path.query;
    var pathname = path.pathname;
    if (pathname == '/ledein')
    {
      IOimage.led=1;
      response.writeHead(200, {'Content-Type': 'text/plain'});
      response.end("IOimage: "+JSON.stringify(IOimage));
    }
    else if (pathname == '/ledaus')
    {
      IOimage.led=0;
      response.writeHead(200, {'Content-Type': 'text/plain'});
      response.end("IOimage: "+JSON.stringify(IOimage));
    }
    else if (pathname == '/io')
    {
      for(var key in query)
      {
        if (query[key] && query[key]==0) IOimage[key]=0;
        if (query[key] && query[key]==1) IOimage[key]=1;
        if (query[key] && query[key]=="aus") IOimage[key]=0;
        if (query[key] && query[key]=="ein") IOimage[key]=1;
        if (query[key] && query[key]=="an") IOimage[key]=1;
        console.log("IOimage."+key+"= "+IOimage[key]);
      }
      response.writeHead(200, {'Content-Type': 'application/json'});
      response.end(JSON.stringify(IOimage));
      /*
      if (query.led && query.led==0) IOimage.led=0;
      if (query.led && query.led==1) IOimage.led=1;
      if (query.led && query.led=="aus") IOimage.led=0;
      if (query.led && query.led=="ein") IOimage.led=1;
      if (query.led && query.led=="an") IOimage.led=1;
      */
    }
    else
    {
      // Im Dateisystem nachschauen
      var uri=path.pathname;
      var mimeTypes = {
          '.html' : 'text/html',
          '.js' : 'text/javascript',
          '.css' : 'text/css',
          '.gif' : 'image/gif',
          '.ico' : 'image/x-icon'
      };

      if (uri=="/") uri="/index.html";
      var filename = Path.join(process.cwd(), "./html/", uri);
      fs.readFile(filename, "binary", function(err, file) {
        if(err) {
          response.writeHead(500, {"Content-Type": mimeTypes[Path.extname(uri)]});
          response.write(err + "\n");
          response.end();
          return;
        }
        response.writeHead(200, {'Content-Type': mimeTypes[Path.extname(uri)]});
        response.write(file, "binary");
        response.end();
      });
    }
    //response.end("Hallo Welt! Pathname="+pathname+" Query="+query);
  }
);

// Server wird gestartet und horcht auf eingehende Verbindungen am Port <port>
server.listen(port);
console.log("Der Server ist erreichbar unter http://127.0.0.1:"+port+"/");
